Changed all instances of EVMS2/LVM2 to EVMS/LVM, respectively. This will keep everyt...
[genkernel.git] / genkernel
index 0f5568cd4a2710e6c87f8238f2ab4e1749f6fa86..2feab05ee93e21a0f7983a0ce0b516ac57c6f8e8 100755 (executable)
--- a/genkernel
+++ b/genkernel
@@ -2,9 +2,12 @@
 # Genkernel v3
 
 PATH="/bin:/usr/bin:/sbin:/usr/sbin"
-GK_V='3.2.12'
+GK_V='3.4.9_pre2'
 
+# Set the default for TMPDIR.  May be modified by genkernel.conf or the
+# --tempdir command line option.
 TMPDIR='/var/tmp/genkernel'
+
 TODEBUGCACHE=1 # Until an error occurs or DEBUGFILE is fully qualified.
 
 small_die() {
@@ -28,7 +31,7 @@ source ${GK_BIN}/gen_bootloader.sh || gen_die "Could not read ${GK_BIN}/gen_boot
 TEMP=${TMPDIR}/$RANDOM.$RANDOM.$RANDOM.$$
 
 trap_cleanup(){
-       #Call exit code of 1 for failure
+       # Call exit code of 1 for failure
        cleanup
        exit 1
 }
@@ -46,10 +49,6 @@ cleanup(){
            CLEAR_CACHE_DIR='yes'
            setup_cache_dir
            echo
-           print_info 1 "CACHE_CPIO_DIR: ${CACHE_CPIO_DIR}"
-           CLEAR_CPIO_CACHE='yes'
-           clear_cpio_dir
-           echo
            print_info 1 "TMPDIR: ${TMPDIR}"
            clear_tmpdir
            fi
@@ -127,27 +126,29 @@ then
        fi
 fi
 
-# Check /boot is mounted
+# Check BOOTDIR is mounted
 if isTrue ${CMD_NOINSTALL}
 then
        isTrue ${MOUNTBOOT} && print_info 2 'Skipping automatic mount of boot'
 else
-       if ! egrep -q ' /boot ' /proc/mounts
+       [[ -d ${BOOTDIR} ]] || gen_die "${BOOTDIR} is not a directory"
+       
+       if ! egrep -q "[[:space:]]${BOOTDIR}[[:space:]]" /proc/mounts
        then
-               if egrep -q '^[^#].+    /boot   ' /etc/fstab
+               if egrep -q "^[^#].+[[:space:]]${BOOTDIR}[[:space:]]" /etc/fstab
                then
                        if isTrue ${MOUNTBOOT}
                        then
-                               if ! mount /boot
+                               if ! mount ${BOOTDIR}
                                then
-                                       print_warning 1 "${BOLD}WARNING${NORMAL}: Failed to mount /boot!"
+                                       print_warning 1 "${BOLD}WARNING${NORMAL}: Failed to mount ${BOOTDIR}!"
                                        echo
                                else
-                                       print_info 1 'mount: /boot mounted successfully!'
+                                       print_info 1 "mount: ${BOOTDIR} mounted successfully!"
                                fi
                        else
-                               print_warning 1 "${BOLD}WARNING${NORMAL}: No mounted /boot partition detected!"
-                               print_warning 1 '         Run ``mount /boot`` to mount it!'
+                               print_warning 1 "${BOLD}WARNING${NORMAL}: No mounted ${BOOTDIR} partition detected!"
+                               print_warning 1 "         Run ``mount ${BOOTDIR}`` to mount it!"
                                echo
                        fi
                fi
@@ -155,40 +156,39 @@ else
        then
                if isTrue ${MOUNTBOOT}
                then
-                       if ! mount -o remount,rw /boot
+                       if ! mount -o remount,rw ${BOOTDIR}
                        then
-                               print_warning 1 "${BOLD}WARNING${NORMAL}: Failed to remount /boot RW!"
+                               print_warning 1 "${BOLD}WARNING${NORMAL}: Failed to remount ${BOOTDIR} RW!"
                                echo
                        else
-                               print_info 1 "mount: /boot remounted read/write successfully!"
+                               print_info 1 "mount: ${BOOTDIR} remounted read/write successfully!"
                                BOOTRW=1
                        fi
                fi
        fi
 fi
 
-# Check whether another Genkernel is running
-GENPIDS="`ps -C genkernel --no-headers -o pid | wc -l`"
-if [ "${GENPIDS}" -gt '3' ]
-then
-       [ "${GENPIDS}" -gt '4' ] && EX='s'
-       print_warning 1 "${BOLD}WARNING${NORMAL}: Another Genkernel instance is running under"
-       print_warning 1 "         process ID${EX} " 0
-       GENPIDS=`ps -C genkernel --no-headers -o pid`
-       echo -n "${GENPIDS}" | sed -e "s/$$//; s/ /, /g"
-       echo 'halting...'
-       echo
-       print_warning 1 'Running multiple genkernels on the same source tree will cause data loss!'
-       print_info 1 "Press ^C to halt; ^D to continue [ ${BOLD}if${NORMAL} you know what you're doing! ]"
-       echo
-       CTEMP="${TEMP}"
-       TEMP=${TMPDIR-/tmp}
-       TEMP=${TEMP}/genkernel.$RANDOM.$RANDOM.$RANDOM.$$
-       print_info 1 'thread: Running multiple genkernels may cause problems!'
-       print_info 1 "thread: Temporary files reallocated to ${TEMP}..."
-       echo
-fi
-
+## Check whether another Genkernel is running
+#GENPIDS="`ps -C genkernel --no-headers -o pid | wc -l`"
+#if [ "${GENPIDS}" -gt '3' ]
+#then
+#      [ "${GENPIDS}" -gt '4' ] && EX='s'
+#      print_warning 1 "${BOLD}WARNING${NORMAL}: Another Genkernel instance is running under"
+#      print_warning 1 "         process ID${EX} " 0
+#      GENPIDS=`ps -C genkernel --no-headers -o pid`
+#      echo -n "${GENPIDS}" | sed -e "s/$$//; s/ /, /g"
+#      echo 'halting...'
+#      echo
+#      print_warning 1 'Running multiple genkernels on the same source tree will cause data loss!'
+#      print_info 1 "Press ^C to halt; ^D to continue [ ${BOLD}if${NORMAL} you know what you're doing! ]"
+#      echo
+#      CTEMP="${TEMP}"
+#      TEMP=${TMPDIR-/tmp}
+#      TEMP=${TEMP}/genkernel.$RANDOM.$RANDOM.$RANDOM.$$
+#      print_info 1 'thread: Running multiple genkernels may cause problems!'
+#      print_info 1 "thread: Temporary files reallocated to ${TEMP}..."
+#      echo
+#fi
 
 KERNCACHE_IS_VALID=0
 if [ "${KERNCACHE}" != "" ] 
@@ -213,11 +213,12 @@ then
        # KV may have changed due to the configuration
        get_KV
 
-       # Compile kernel
-       [ "${GENERATE_Z_IMAGE}" = '' ] && compile_kernel
+       # Compile kernel; If using --genzimage, or building a mips kernel, skip compile
+       # till after initrd/initramfs is done
+       [ "${GENERATE_Z_IMAGE}" = '' -a ${BUILD_INITRAMFS} -eq 0 ] && compile_kernel
 
        # Compile modules
-       if [ ${BUILD_MODULES} -eq 1 ]
+       if [ ${BUILD_MODULES} -eq 1 -a ${BUILD_STATIC} -eq 0 ]
        then
                compile_modules
        fi
@@ -228,7 +229,13 @@ then
                [ ! -e '/etc/kernels' ] && mkdir -p /etc/kernels
                cp "${KERNEL_DIR}/.config" "/etc/kernels/kernel-config-${ARCH}-${KV}"
        fi
-       [ "${KERNCACHE}" != "" ] && gen_kerncache
+       if [ "${KERNCACHE}" != "" ]
+       then
+               if [ "${GENERATE_Z_IMAGE}" = '' -a ${BUILD_INITRAMFS} -eq 0 ]
+               then
+                       gen_kerncache
+               fi
+       fi
 fi
 
 if ! isTrue "${CMD_NOINSTALL}"
@@ -241,9 +248,11 @@ fi
 
 if [ "${KERNCACHE}" != "" -a "${KERNCACHE_IS_VALID}" != "0" ] 
 then
-       gen_kerncache_extract_modules
+       [ ${BUILD_STATIC} -eq 0 ] && gen_kerncache_extract_modules
+       gen_kerncache_extract_config
 fi
 
+
 # Run callback
 if [ "${CMD_CALLBACK}" != "" ]
 then
@@ -279,30 +288,14 @@ fi
 
 if [ "${BUILD_INITRD}" -eq '1' ]
 then
-       # Only compile insmod if we're installing modules onto the initrd
-       if [ "${NOINITRDMODULES}" = '' ]
-       then
-               if [ "${KERN_24}" != '1' ]
-               then
-                       # Compile module-init-tools
-                       compile_module_init_tools
-               else
-                       compile_modutils
-               fi
-       fi
-       
        [ "${DISKLABEL}" -eq '1' ] && compile_e2fsprogs
 
-       if [ "${KERN_24}" != '1' -a "${UDEV}" -eq '1' ] 
+       if [ "${KERN_24}" -eq '1' ] 
        then
-               compile_udev 
-       else
-               DEVFS=1
-               UDEV=0
                compile_devfsd
        fi
 
-       if [ "${KERN_24}" != '1' -a  "${CMD_BOOTSPLASH}" != '1' ]
+       if [ "${KERN_24}" != '1' ]
        then
            if [ "${BUSYBOX}" -eq '1' ]
            then
@@ -322,10 +315,14 @@ else
 fi
 
 # Pegasos fix
-if [ "${GENERATE_Z_IMAGE}" != '' ]
+if [ "${GENERATE_Z_IMAGE}" != '' -o ${BUILD_INITRAMFS} -eq 1 ]
 then
-       # Compile kernel, intergrating the initrd into it for Pegasos
+       # Compile kernel, intergrating the initrd into it for Pegasos & mips
        compile_kernel
+
+       # We skipped the kernel build and kerncache generation
+       # So do it here
+       [ "${KERNCACHE}" != "" ] && gen_kerncache
 fi
 
 [ "${MINKERNPACKAGE}" != '' ] && gen_minkernpackage
@@ -348,7 +345,7 @@ then
                print_info 1 ''
                print_info 1 '    Where $ROOT is the device node for your root partition as the'
                print_info 1 '    one specified in /etc/fstab'
-       elif [ "${KERN_24}" != '1' -a  "${CMD_BOOTSPLASH}" != '1' ]
+       elif [ "${KERN_24}" != '1' ]
        then
                print_info 1 '    real_root=/dev/$ROOT'
                print_info 1 ''
@@ -378,55 +375,16 @@ then
        echo
        print_info 1 'WARNING... WARNING... WARNING...'
        print_info 1 'Additional kernel cmdline arguments that *may* be required to boot properly...'
-       [ "${GENSPLASH}" -eq '1' ] && print_info 1 "add \"vga=791 splash=silent,theme:${GENSPLASH_THEME} CONSOLE=/dev/tty1 quiet\" if you use a gensplash framebuffer ]"
-       [ "${BOOTSPLASH}" -eq '1' ] && print_info 1 'add "vga=791 splash=silent" if you use a bootsplash framebuffer'
-       [ "${LVM2}" -eq '1' ] && print_info 1 'add "dolvm2" for lvm2 support'
-       [ "${EVMS2}" -eq '1' ] && print_info 1 'add "doevms" for evms support'
+       [ "${GENSPLASH}" -eq '1' ] && print_info 1 "add \"vga=791 splash=silent,theme:${GENSPLASH_THEME} console=tty1 quiet\" if you use a gensplash framebuffer ]"
+       [ "${LVM}" -eq '1' ] && print_info 1 'add "dolvm" for lvm support'
+       [ "${EVMS}" -eq '1' ] && print_info 1 'add "doevms" for evms support'
        [ "${DMRAID}" -eq '1' ] && print_info 1 'add "dodmraid" for dmraid support'
        [ "${DMRAID}" -eq '1' ] && print_info 1 '       or "dodmraid=<additional options>"'
        [ "${UNIONFS}" -eq '1' ] && print_info 1 'add "unionfs" for unionfs support'
        [ "${UNIONFS}" -eq '1' ] && print_info 1 '      or "unionfs=<block_device>"'
 fi
 
-if [ "${CMD_NOINSTALL}" != '1' -a "${SYMLINK}" = '1' ]
-then 
-    echo
-    print_info 1 'Creating symlinks'
-    
-    
-    print_info 1 '         creating kernel name symlink!'
-    if [ -e /boot/kernel-${KNAME}-${ARCH}-${KV} ]
-    then
-       /bin/rm /boot/kernel
-        ln -s /boot/kernel-${KNAME}-${ARCH}-${KV} /boot/kernel
-        ret=$?
-        [ ${ret} = '1' ] && print_error 1 'kernel link failed'
-    fi
-    
-    if [ "${KERN_24}" != '1' -a  "${CMD_BOOTSPLASH}" != '1' ]
-    then
-       print_info 1 '      creating initramfs name symlink!'
-       if [ -e /boot/initramfs-${KNAME}-${ARCH}-${KV} ]
-       then
-           /bin/rm /boot/initramfs
-           ln -s /boot/initramfs-${KNAME}-${ARCH}-${KV} /boot/initramfs
-           ret=$?
-           [ ${ret} = '1' ] && print_error 1 'initramfs link failed'
-       fi
-    else
-       print_info 1 '      creating initrd name symlink!'
-       if [ -e /boot/initrd-${KNAME}-${ARCH}-${KV} ]
-       then
-           /bin/rm /boot/initrd
-           ln -s /boot/initrd-${KNAME}-${ARCH}-${KV} /boot/initrd
-           ret=$?
-           [ ${ret} = '1' ] && print_error 1 'initrd link failed'
-       fi
-    fi
-fi
-
-
-[ "${BOOTRW}" != '' ] && mount -o remount,ro /boot
+[ "${BOOTRW}" != '' ] && mount -o remount,ro ${BOOTDIR}
 
 echo
 print_info 1 'Do NOT report kernel bugs as genkernel bugs unless your bug'